[LeetCode] 139. 单词拆分
题目链接 : https://leetcode-cn.com/problems/word-break/
题目描述:
给定一个非空字符串 s 和一个包含非空单词列表的字典 wordDict,判定 s 是否可以被空格拆分为一个或多个在字典中出现的单词。
说明:
- 拆分时可以重复使用字典中的单词。
- 你可以假设字典中没有重复的单词。
示例:
示例 1:
输入: s = "leetcode", wordDict = ["leet", "code"]
输出: true
解释: 返回 true 因为 "leetcode" 可以被拆分成 "leet code"。
示例 2:
输入: s = "applepenapple", wordDict = ["apple", "pen"]
输出: true
解释: 返回 true 因为 "applepenapple" 可以被拆分成 "apple pen apple"。
注意你可以重复使用字典中的单词。
示例 3:
输入: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
输出: false
思路:
动态规划
思路一:自顶向下,
思路二:自底向上,
dp[i]
表示s
到i
位置是否可以由wordDict
组成
所以有 如果dp[i - j]
是true
并且s[j:i]
在wordDict
里dp[i] = true
;
两种都很容易理解的!看代码就行了
相关题型: 140. 单词拆分 II
代码:
思路一:
class Solution:
def wordBreak(self, s: str, wordDict: List[str]) -> bool:
import functools
wordDict = set(wordDict)
if not wordDict:return not s
# 找最长单词的长度
max_len = max(map(len, wordDict))
@functools.lru_cache(None)
def helper(s):
# 递归终止条件
if not s:
return True
for i in range(len(s)):
# 判断是否满足条件
if i < max_len and s[:i+1] in wordDict and helper(s[i+1:]):
return True
return False
return helper(s)
java
class Solution {
public boolean wordBreak(String s, List<String> wordDict) {
int max_len = 0;
for (String word : wordDict) max_len = Math.max(max_len, word.length());
return helper(s, max_len, wordDict, new HashMap<String, Boolean>());
}
private boolean helper(String s, int max_len, List<String> wordDict, HashMap<String, Boolean> cache) {
if (cache.containsKey(s)) return cache.get(s);
if (s == null || s.length() == 0) return true;
for (int i = 0; i < s.length(); i++) {
if (i < max_len && wordDict.contains(s.substring(0, i + 1)) && helper(s.substring(i + 1), max_len, wordDict, cache)) {
cache.put(s, true);
return true;
}
}
cache.put(s, false);
return false;
}
}
思路二:
class Solution:
def wordBreak(self, s: str, wordDict: List[str]) -> bool:
n = len(s)
if not wordDict: return not s
dp = [False] * (n + 1)
dp[0] = True
for i in range(1, n + 1):
for j in range(i - 1, -1, -1):
if dp[j] and s[j:i] in wordDict:
dp[i] = True
break
return dp[-1]
java
class Solution {
public boolean wordBreak(String s, List<String> wordDict) {
if (wordDict == null || wordDict.size() == 0) return s.isEmpty();
int n = s.length();
boolean[] dp = new boolean[n + 1];
dp[0] = true;
for (int i = 1; i <= n; i++) {
for (int j = i - 1; j >= 0; j--) {
if (dp[j] && wordDict.contains(s.substring(j, i))) {
dp[i] = true;
break;
}
}
}
return dp[n];
}
}